# db_upgrade |

`

###

    db_upgrade [-NsV] [-h home] file ...

# Description

The db_upgrade utility upgrades the Berkeley DB version of one or more files and the databases they contain to the current release version.

The options are as follows:

-h
  Specify a home directory for the database environment; by default, the current working directory is used.

-N
  Do not acquire shared region locks while running. Other problems such as potentially fatal errors in Berkeley DB will be ignored as well. This option is intended only for debugging errors and should not be used under any other circumstances.

-s
  This flag is only meaningful when upgrading databases from releases before the Berkeley DB 3.1 release.

  As part of the upgrade from the Berkeley DB 3.0 release to the 3.1 release, the on-disk format of duplicate data items changed. To correctly upgrade the format requires applications specify if duplicate data items in the database are sorted or not. Specifying the -s flag means that the duplicates are sorted, otherwise they are assumed to be unsorted. Incorrectly specifying the value of this flag may lead to database corruption.

  Because the db_upgrade utility upgrades a physical file (including all of the databases it contains), it is not possible to use db_upgrade to upgrade files where some of the databases it includes have sorted duplicate data items and some of the databases it includes have unsorted duplicate data items. If the file does not have more than a single database, or the databases do not support duplicate data items, or all of the databases that support duplicate data items support the same style of duplicates (either sorted or unsorted), db_upgrade will work correctly as long as the -s flag is correctly specified. Otherwise, the file cannot be upgraded using db_upgrade, and must be upgraded manually using the db_dump and db_load utilities.

-V
  Write the version number to the standard output and exit.

It is important to realize that Berkeley DB database upgrades are done in place, and so are potentially destructive. This means that if the system crashes during the upgrade procedure, or if the upgrade procedure runs out of disk space, the databases may be left in an inconsistent and unrecoverable state. See Upgrading databases for more information.

The db_upgrade utility may be used with a Berkeley DB environment (as described for the -h option, the environment variable DB_HOME, or, because the utility was run in a directory containing a Berkeley DB environment). In order to avoid environment corruption when using a Berkeley DB environment, db_upgrade should always be given the chance to detach from the environment and exit gracefully. To cause db_upgrade to release all environment resources and exit cleanly, send it an interrupt signal (SIGINT).

The db_upgrade utility exits 0 on success, and >0 if an error occurs.

# Environment Variables

DB_HOME
  If the -h option is not specified and the environment variable DB_HOME is set, it is used as the path of the database home, as described in DBENV->open.

# See Also

berkeley_db_svc, db_archive, db_checkpoint, db_deadlock, db_dump, db_load, db_recover, db_stat, db_upgrade, and db_verify.`

Copyright Sleepycat Software